import { PRODUCT_FAMILY } from '@app/core/constants/product.constants';
import { DEFAULT_FAMILY } from '@app/core/i18n/constants/translate.constants';
import {
  TableFamilyConfig,
  TableHeader,
} from '@app/presentation/layout/mo-tables/interfaces/table.interface';
import {
  TABLE_CUSTOMERS_TABLE_BNPL,
  TABLE_CUSTOMER_PROFILE_ASSOCIATED_LOANS_BNPL,
  TABLE_CUSTOMER_PROFILE_PAYMENTS_BNPL,
} from './tables-bnpl/customers.table';
import { TABLE_PRE_CUSTOMERS_TABLE_BNPL } from './tables-bnpl/pre-customers.table';
import {
  TABLE_CUSTOMERS_TABLE_CREDIT_CARD,
  TABLE_CUSTOMER_PROFILE_ASSOCIATED_LOANS_CREDIT_CARD,
  TABLE_CUSTOMER_PROFILE_PAYMENTS_CREDIT_CARD,
} from './tables-credit-card/customers.table';
import { TABLE_PRE_CUSTOMERS_TABLE_CREDIT_CARD } from './tables-credit-card/pre-customers.table';
import {
  TABLE_CUSTOMERS_DEFAULT,
  TABLE_CUSTOMER_PROFILE_ASSOCIATED_LOANS_DEFAULT,
  TABLE_CUSTOMER_PROFILE_PAYMENTS_DEFAULT,
} from './tables-default/customers.table';
import { TABLE_PRE_CUSTOMERS_TABLE_DEFAULT } from './tables-default/pre-customers.table';
import {
  TABLE_CUSTOMERS_TABLE_MCA,
  TABLE_CUSTOMER_PROFILE_ASSOCIATED_LOANS_MCA,
  TABLE_CUSTOMER_PROFILE_PAYMENTS_MCA,
} from './tables-mca/customers.table';
import { TABLE_PRE_CUSTOMERS_TABLE_MCA } from './tables-mca/pre-customers.table';
import {
  TABLE_CUSTOMERS_TABLE_MICRO_CREDIT,
  TABLE_CUSTOMER_PROFILE_ASSOCIATED_LOANS_MICRO_CREDIT,
  TABLE_CUSTOMER_PROFILE_PAYMENTS_MICRO_CREDIT,
} from './tables-micro-credit/customers.table';
import { TABLE_PRE_CUSTOMERS_TABLE_MICRO_CREDIT } from './tables-micro-credit/pre-customers.table';

export enum CUSTOMERS_TABLES {
  CUSTOMERS = 'customers',
  CUSTOMER_PROFILE_ASSOCIATED_LOANS = 'customers-profile-associated-loans',
  CUSTOMER_PROFILE_PAYMENTS = 'customers-profile-payments',
  PRE_CUSTOMER = 'pre-customers',
}

export const TABLES_BY_PRODUCT_FAMILY: TableFamilyConfig = {
  [DEFAULT_FAMILY]: {
    [CUSTOMERS_TABLES.CUSTOMERS]: TABLE_CUSTOMERS_DEFAULT,
    [CUSTOMERS_TABLES.CUSTOMER_PROFILE_ASSOCIATED_LOANS]:
      TABLE_CUSTOMER_PROFILE_ASSOCIATED_LOANS_DEFAULT,
    [CUSTOMERS_TABLES.CUSTOMER_PROFILE_PAYMENTS]:
      TABLE_CUSTOMER_PROFILE_PAYMENTS_DEFAULT,
    [CUSTOMERS_TABLES.PRE_CUSTOMER]: TABLE_PRE_CUSTOMERS_TABLE_DEFAULT,
  },
  [PRODUCT_FAMILY.BNPL]: {
    [CUSTOMERS_TABLES.CUSTOMERS]: TABLE_CUSTOMERS_TABLE_BNPL,
    [CUSTOMERS_TABLES.CUSTOMER_PROFILE_ASSOCIATED_LOANS]:
      TABLE_CUSTOMER_PROFILE_ASSOCIATED_LOANS_BNPL,
    [CUSTOMERS_TABLES.CUSTOMER_PROFILE_PAYMENTS]:
      TABLE_CUSTOMER_PROFILE_PAYMENTS_BNPL,
    [CUSTOMERS_TABLES.PRE_CUSTOMER]: TABLE_PRE_CUSTOMERS_TABLE_BNPL,
  },
  [PRODUCT_FAMILY.MCA]: {
    [CUSTOMERS_TABLES.CUSTOMERS]: TABLE_CUSTOMERS_TABLE_MCA,
    [CUSTOMERS_TABLES.CUSTOMER_PROFILE_ASSOCIATED_LOANS]:
      TABLE_CUSTOMER_PROFILE_ASSOCIATED_LOANS_MCA,
    [CUSTOMERS_TABLES.CUSTOMER_PROFILE_PAYMENTS]:
      TABLE_CUSTOMER_PROFILE_PAYMENTS_MCA,
    [CUSTOMERS_TABLES.PRE_CUSTOMER]: TABLE_PRE_CUSTOMERS_TABLE_MCA,
  },
  [PRODUCT_FAMILY.CREDIT_CARD]: {
    [CUSTOMERS_TABLES.CUSTOMERS]: TABLE_CUSTOMERS_TABLE_CREDIT_CARD,
    [CUSTOMERS_TABLES.CUSTOMER_PROFILE_ASSOCIATED_LOANS]:
      TABLE_CUSTOMER_PROFILE_ASSOCIATED_LOANS_CREDIT_CARD,
    [CUSTOMERS_TABLES.CUSTOMER_PROFILE_PAYMENTS]:
      TABLE_CUSTOMER_PROFILE_PAYMENTS_CREDIT_CARD,
    [CUSTOMERS_TABLES.PRE_CUSTOMER]: TABLE_PRE_CUSTOMERS_TABLE_CREDIT_CARD,
  },
  [PRODUCT_FAMILY.MICRO_CREDIT]: {
    [CUSTOMERS_TABLES.CUSTOMERS]: TABLE_CUSTOMERS_TABLE_MICRO_CREDIT,
    [CUSTOMERS_TABLES.CUSTOMER_PROFILE_ASSOCIATED_LOANS]:
      TABLE_CUSTOMER_PROFILE_ASSOCIATED_LOANS_MICRO_CREDIT,
    [CUSTOMERS_TABLES.CUSTOMER_PROFILE_PAYMENTS]:
      TABLE_CUSTOMER_PROFILE_PAYMENTS_MICRO_CREDIT,
    [CUSTOMERS_TABLES.PRE_CUSTOMER]: TABLE_PRE_CUSTOMERS_TABLE_MICRO_CREDIT,
  },
};

export const getCustomersTablePerFamily = (
  family: string,
  table: CUSTOMERS_TABLES
): TableHeader[] => {
  return !!family
    ? TABLES_BY_PRODUCT_FAMILY[family][table]
    : TABLES_BY_PRODUCT_FAMILY[DEFAULT_FAMILY][table];
};
